Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging

Public Class frmImage
    Inherits System.Windows.Forms.Form
    Private strDirectory As String
    Friend WithEvents ssinfo As System.Windows.Forms.StatusStrip
    Friend WithEvents tsPath As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents tssSize As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents chName As System.Windows.Forms.ColumnHeader
    Friend WithEvents chExt As System.Windows.Forms.ColumnHeader
    Friend WithEvents pbResize As System.Windows.Forms.PictureBox
    Friend WithEvents plShow As System.Windows.Forms.Panel
    Friend WithEvents btnCrop As System.Windows.Forms.Button
    Friend WithEvents tsFound As System.Windows.Forms.ToolStripStatusLabel

    'bitmap to contain the cropped image
    Dim cropBitmap As Bitmap
    'the position and size to crop the image file
    Dim cropX As Integer
    Dim cropY As Integer
    Dim cropWidth As Integer
    Dim cropHeight As Integer

    Dim oCropX As Integer
    Dim oCropY As Integer
    'create a pen object
    Public cropPen As Pen
    'select a default crop line size
    Public cropPenSize As Integer = 0.5 '2
    'will contain the dashStyle of the pen
    Public cropDashStyle As Drawing2D.DashStyle = Drawing2D.DashStyle.Dash
    Friend WithEvents pbxRotLeft As System.Windows.Forms.PictureBox
    Friend WithEvents pbxRight As System.Windows.Forms.PictureBox
    Friend WithEvents pbxMirror As System.Windows.Forms.PictureBox
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents tssCropsize As System.Windows.Forms.ToolStripStatusLabel
    'set a default crop line color
    Public cropPenColor As Color = Color.Aqua
#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents TreeView1 As System.Windows.Forms.TreeView
    Friend WithEvents ListView1 As System.Windows.Forms.ListView

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmImage))
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.TreeView1 = New System.Windows.Forms.TreeView
        Me.ListView1 = New System.Windows.Forms.ListView
        Me.chName = New System.Windows.Forms.ColumnHeader
        Me.chExt = New System.Windows.Forms.ColumnHeader
        Me.ssinfo = New System.Windows.Forms.StatusStrip
        Me.tsFound = New System.Windows.Forms.ToolStripStatusLabel
        Me.tsPath = New System.Windows.Forms.ToolStripStatusLabel
        Me.tssSize = New System.Windows.Forms.ToolStripStatusLabel
        Me.pbResize = New System.Windows.Forms.PictureBox
        Me.plShow = New System.Windows.Forms.Panel
        Me.btnCrop = New System.Windows.Forms.Button
        Me.pbxRotLeft = New System.Windows.Forms.PictureBox
        Me.pbxRight = New System.Windows.Forms.PictureBox
        Me.pbxMirror = New System.Windows.Forms.PictureBox
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.tssCropsize = New System.Windows.Forms.ToolStripStatusLabel
        Me.ssinfo.SuspendLayout()
        CType(Me.pbResize, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.plShow.SuspendLayout()
        CType(Me.pbxRotLeft, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.pbxRight, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.pbxMirror, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'ImageList1
        '
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        Me.ImageList1.Images.SetKeyName(0, "harddrive.ico")
        Me.ImageList1.Images.SetKeyName(1, "ClosedFolder.ico")
        Me.ImageList1.Images.SetKeyName(2, "openfolder.ico")
        Me.ImageList1.Images.SetKeyName(3, "img.ico")
        '
        'TreeView1
        '
        Me.TreeView1.ImageIndex = 0
        Me.TreeView1.ImageList = Me.ImageList1
        Me.TreeView1.Location = New System.Drawing.Point(12, 12)
        Me.TreeView1.Name = "TreeView1"
        Me.TreeView1.SelectedImageIndex = 0
        Me.TreeView1.Size = New System.Drawing.Size(182, 215)
        Me.TreeView1.TabIndex = 2
        '
        'ListView1
        '
        Me.ListView1.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chName, Me.chExt})
        Me.ListView1.GridLines = True
        Me.ListView1.LabelWrap = False
        Me.ListView1.LargeImageList = Me.ImageList1
        Me.ListView1.Location = New System.Drawing.Point(12, 233)
        Me.ListView1.Name = "ListView1"
        Me.ListView1.Size = New System.Drawing.Size(182, 189)
        Me.ListView1.SmallImageList = Me.ImageList1
        Me.ListView1.Sorting = System.Windows.Forms.SortOrder.Ascending
        Me.ListView1.TabIndex = 0
        Me.ListView1.UseCompatibleStateImageBehavior = False
        Me.ListView1.View = System.Windows.Forms.View.Details
        '
        'chName
        '
        Me.chName.Text = "Name"
        Me.chName.Width = 120
        '
        'chExt
        '
        Me.chExt.Text = "Ext"
        '
        'ssinfo
        '
        Me.ssinfo.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.tsFound, Me.tsPath, Me.tssSize, Me.tssCropsize})
        Me.ssinfo.Location = New System.Drawing.Point(0, 431)
        Me.ssinfo.Name = "ssinfo"
        Me.ssinfo.Size = New System.Drawing.Size(629, 22)
        Me.ssinfo.TabIndex = 3
        Me.ssinfo.Text = "StatusStrip1"
        '
        'tsFound
        '
        Me.tsFound.Name = "tsFound"
        Me.tsFound.Size = New System.Drawing.Size(46, 17)
        Me.tsFound.Text = "0 Found"
        Me.tsFound.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'tsPath
        '
        Me.tsPath.AutoSize = False
        Me.tsPath.Name = "tsPath"
        Me.tsPath.Padding = New System.Windows.Forms.Padding(250, 0, 0, 0)
        Me.tsPath.Size = New System.Drawing.Size(272, 17)
        Me.tsPath.Text = "C:\"
        Me.tsPath.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'tssSize
        '
        Me.tssSize.AutoSize = False
        Me.tssSize.Name = "tssSize"
        Me.tssSize.Padding = New System.Windows.Forms.Padding(100, 0, 0, 0)
        Me.tssSize.Size = New System.Drawing.Size(126, 17)
        Me.tssSize.Text = "Size"
        Me.tssSize.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'pbResize
        '
        Me.pbResize.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.pbResize.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pbResize.Location = New System.Drawing.Point(13, 14)
        Me.pbResize.Name = "pbResize"
        Me.pbResize.Size = New System.Drawing.Size(39, 34)
        Me.pbResize.TabIndex = 4
        Me.pbResize.TabStop = False
        Me.pbResize.Visible = False
        '
        'plShow
        '
        Me.plShow.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.plShow.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.plShow.Controls.Add(Me.pbResize)
        Me.plShow.Location = New System.Drawing.Point(200, 12)
        Me.plShow.Name = "plShow"
        Me.plShow.Size = New System.Drawing.Size(417, 366)
        Me.plShow.TabIndex = 5
        '
        'btnCrop
        '
        Me.btnCrop.Location = New System.Drawing.Point(215, 384)
        Me.btnCrop.Name = "btnCrop"
        Me.btnCrop.Size = New System.Drawing.Size(75, 23)
        Me.btnCrop.TabIndex = 5
        Me.btnCrop.Text = "Crop "
        Me.btnCrop.UseVisualStyleBackColor = True
        '
        'pbxRotLeft
        '
        Me.pbxRotLeft.BackColor = System.Drawing.Color.White
        Me.pbxRotLeft.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pbxRotLeft.Image = CType(resources.GetObject("pbxRotLeft.Image"), System.Drawing.Image)
        Me.pbxRotLeft.Location = New System.Drawing.Point(305, 384)
        Me.pbxRotLeft.Name = "pbxRotLeft"
        Me.pbxRotLeft.Size = New System.Drawing.Size(30, 30)
        Me.pbxRotLeft.TabIndex = 10
        Me.pbxRotLeft.TabStop = False
        Me.ToolTip1.SetToolTip(Me.pbxRotLeft, "Rotate Left")
        '
        'pbxRight
        '
        Me.pbxRight.BackColor = System.Drawing.Color.White
        Me.pbxRight.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pbxRight.Image = CType(resources.GetObject("pbxRight.Image"), System.Drawing.Image)
        Me.pbxRight.Location = New System.Drawing.Point(344, 384)
        Me.pbxRight.Name = "pbxRight"
        Me.pbxRight.Size = New System.Drawing.Size(30, 30)
        Me.pbxRight.TabIndex = 11
        Me.pbxRight.TabStop = False
        Me.ToolTip1.SetToolTip(Me.pbxRight, "Rotate Right")
        '
        'pbxMirror
        '
        Me.pbxMirror.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pbxMirror.Image = CType(resources.GetObject("pbxMirror.Image"), System.Drawing.Image)
        Me.pbxMirror.Location = New System.Drawing.Point(380, 384)
        Me.pbxMirror.Name = "pbxMirror"
        Me.pbxMirror.Size = New System.Drawing.Size(30, 30)
        Me.pbxMirror.TabIndex = 12
        Me.pbxMirror.TabStop = False
        Me.ToolTip1.SetToolTip(Me.pbxMirror, "Mirror")
        '
        'tssCropsize
        '
        Me.tssCropsize.Name = "tssCropsize"
        Me.tssCropsize.Size = New System.Drawing.Size(52, 17)
        Me.tssCropsize.Text = "Crop Size"
        '
        'frmImage
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(629, 453)
        Me.Controls.Add(Me.pbxMirror)
        Me.Controls.Add(Me.pbxRight)
        Me.Controls.Add(Me.pbxRotLeft)
        Me.Controls.Add(Me.btnCrop)
        Me.Controls.Add(Me.plShow)
        Me.Controls.Add(Me.ssinfo)
        Me.Controls.Add(Me.ListView1)
        Me.Controls.Add(Me.TreeView1)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "frmImage"
        Me.Text = "Quick_Image"
        Me.ssinfo.ResumeLayout(False)
        Me.ssinfo.PerformLayout()
        CType(Me.pbResize, System.ComponentModel.ISupportInitialize).EndInit()
        Me.plShow.ResumeLayout(False)
        CType(Me.pbxRotLeft, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.pbxRight, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.pbxMirror, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        TreeView1.BeginUpdate()

        ' Make disk drives the root nodes. 
        Dim astrDrives As String() = Directory.GetLogicalDrives()

        Dim strDrive As String
        For Each strDrive In astrDrives
            Dim tnDrive As New TreeNode(strDrive, 0, 0)
            TreeView1.Nodes.Add(tnDrive)
            If strDrive <> "A:\" Then
                AddDirectories(tnDrive)

                ' Set the C drive as the default selection.
                If strDrive = "C:\" Then
                    TreeView1.SelectedNode = tnDrive
                End If
            End If
        Next
        TreeView1.EndUpdate()

    End Sub

    ' This subroutine is used to add a child node for every directory under its
    ' parent node, which is passed as an argument. See further comments in the
    ' OnBeforeExpand event handler.
    Sub AddDirectories(ByVal tn As TreeNode)
        tn.Nodes.Clear()

        Dim strPath As String = tn.FullPath
        Dim diDirectory As New DirectoryInfo(strPath)
        Dim adiDirectories() As DirectoryInfo

        Try
            ' Get an array of all sub-directories as DirectoryInfo objects.
            adiDirectories = diDirectory.GetDirectories()
        Catch exp As Exception
            Exit Sub
        End Try

        Dim di As DirectoryInfo
        For Each di In adiDirectories
            ' Create a child node for every sub-directory, passing in the directory
            ' name and the images its node will use.
            Dim tnDir As New TreeNode(di.Name, 1, 2)
            ' Add the new child node to the parent node.
            tn.Nodes.Add(tnDir)
        Next
    End Sub
    Private Sub TreeView1_AfterSelect(ByVal sender As Object, ByVal tvea As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        ShowFiles(tvea.Node.FullPath) 'show files in listview
        tsFound.Text = ListView1.Items.Count.ToString & " found" 'show how many images found
        tsPath.Text = tvea.Node.FullPath 'show the selected path
    End Sub
    Private Sub TreeView1_BeforeExpand(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeExpand
        TreeView1.BeginUpdate()

        Dim tn As TreeNode
        ' Add child nodes for each child node in the node clicked by the user. 
        ' For performance reasons each node in the DirectoryTreeView 
        ' contains only the next level of child nodes in order to display the + sign 
        ' to indicate whether the user can expand the node. So when the user expands
        ' a node, in order for the + sign to be appropriately displayed for the next
        ' level of child nodes, *their* child nodes have to be added.
        For Each tn In e.Node.Nodes
            AddDirectories(tn)
        Next tn

        TreeView1.EndUpdate()

    End Sub
    Private Sub frmDirDemo_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Leave
        End
    End Sub
    ' This subroutine is used to display a list of all files in the directory
    ' currently selected by the user from the custom TreeView control.
    Public Sub ShowFiles(ByVal strDirectory As String)
        ' Save the directory name as a field.
        Me.strDirectory = strDirectory

        Dim diDirectories As New DirectoryInfo(strDirectory)
        Dim afiFiles() As FileInfo
        ' Clear listview and reset view type
        ListView1.Clear()
        ListView1.View = View.Details
        'Create the columns.
        With ListView1.Columns
            .Add("Name", 120, HorizontalAlignment.Left)
            .Add("Ext", 40, HorizontalAlignment.Left)
        End With

        Try
            ' Call the convenient GetFiles method to get an array of all files
            ' in the directory.
            afiFiles = diDirectories.GetFiles()
        Catch
            Return
        End Try

        Dim fi As FileInfo
        For Each fi In afiFiles
            ' Create ListViewItem.
            If Path.GetExtension(fi.Name).ToUpper = ".JPG" Or _
               Path.GetExtension(fi.Name).ToUpper = ".BMP" Or _
               Path.GetExtension(fi.Name).ToUpper = ".JPEG" Or _
               Path.GetExtension(fi.Name).ToUpper = ".EMF" Or _
               Path.GetExtension(fi.Name).ToUpper = ".WMF" Or _
               Path.GetExtension(fi.Name).ToUpper = ".GIF" Or _
               Path.GetExtension(fi.Name).ToLower = ".gif" Or _
               Path.GetExtension(fi.Name).ToUpper = ".TIF" Or _
               Path.GetExtension(fi.Name).ToLower = ".tif" Or _
               Path.GetExtension(fi.Name).ToUpper = ".ICO" Or _
               Path.GetExtension(fi.Name).ToLower = ".ico" Or _
               Path.GetExtension(fi.Name).ToUpper = ".PNG" Then
                Dim lvi As New ListViewItem(Path.GetFileNameWithoutExtension(fi.Name))

                'Assign ImageIndex 
                lvi.ImageIndex = 3

                ' Add file extension and file length.
                lvi.SubItems.Add(fi.Extension)
                lvi.SubItems.Add(fi.Length.ToString("N0"))

                ' Add completed ListViewItem to FileListView.
                ListView1.Items.Add(lvi)
            End If
        Next fi
    End Sub
    Private Sub ListView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        Dim lvi As ListViewItem
        Dim picPath As String
        For Each lvi In ListView1.SelectedItems
            Try
                picPath = lvi.SubItems.Item(0).Text + lvi.SubItems.Item(1).Text 'get pictures filename for selected item
                tsPath.Text = Path.Combine(strDirectory, picPath) 'combine path and filename 
                pbResize.Image = Image.FromFile(tsPath.Text)
                redopic()
                tssSize.Text = "Size = " & pbResize.Image.Width.ToString & " x " & pbResize.Image.Height.ToString 'show image size on the panel
                tsFound.Text = (lvi.Index + 1).ToString & " / " & ListView1.Items.Count.ToString 'show the sequence of the image on the panel
            Catch
                ' Do nothing. Just pass to Next lvi.
                Exit Try
            End Try
        Next lvi
    End Sub
    Public Sub redopic()
        'Resize picture keeping Image Ratio
        Dim X, Y, ScrX, ScrY, PosX, PosY, PicX, PicY As Integer
        Dim ratio As Double

        Try
            pbResize.Visible = False 'Hide picture

            PicX = pbResize.Image.Width 'get pictures width
            PicY = pbResize.Image.Height 'get pictures height
            ratio = PicX / PicY 'calculate aspect ratio

            ScrX = plShow.Width  'get panel width
            ScrY = plShow.Height  'get panel height


            If PicX >= PicY Then 'check whether pic.width greater than height
                pbResize.Width = ScrX ' If yes, then main size is width
                pbResize.Height = CInt(pbResize.Width / ratio) 'calculate height with aspect ratio
                If pbResize.Height > ScrY Then
                    pbResize.Height = ScrY 'If no, then main size is height
                    pbResize.Width = CInt(pbResize.Height * ratio) 'calculate width with aspect ratio
                End If
            Else
                pbResize.Height = ScrY 'If no, then main size is height
                pbResize.Width = CInt(pbResize.Height * ratio) 'calculate width with aspect ratio
                If pbResize.Width > ScrX Then
                    pbResize.Width = ScrX 'If yes, then main size is width
                    pbResize.Height = CInt(pbResize.Width / ratio) 'calculate height with aspect ratio
                End If
            End If
            pbResize.SizeMode = PictureBoxSizeMode.StretchImage 'resize the picture


            X = pbResize.Width 'get width
            Y = pbResize.Height 'get height

            PosX = CInt((ScrX - X) / 2) 'calculate position X
            PosY = CInt((ScrY - Y) / 2) 'calculate position Y

            pbResize.Left = PosX 'adjust position
            pbResize.Top = PosY

            pbResize.Visible = True 'show picture
        Catch
        End Try

    End Sub
    Private Sub btnCrop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCrop.Click
        'Crop Code
        Try
            If cropWidth < 1 Then
                'if there are not proper cropping cordinates, then throw a message and exit code
                MessageBox.Show("You need to first select what portion of the image to crop.", " No cropping Cordinates!", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

            'a rectangle to set the location and size from the source image
            Dim rect As Rectangle = New Rectangle(cropX, cropY, cropWidth, cropHeight)
            Dim bit As Bitmap = New Bitmap(pbResize.Image, pbResize.Width, pbResize.Height)

            'create a new bitmap with the width/height values that were specified in the textboxes.
            cropBitmap = New Bitmap(cropWidth, cropHeight)
            'a new Graphics object that will draw on the cropBitmap
            Dim g As Graphics = Graphics.FromImage(cropBitmap)
            'draw the portion of the image that you supplied cropping values for.
            g.DrawImage(bit, 0, 0, rect, GraphicsUnit.Pixel)
            frmCrop.pbCrop.Image = cropBitmap
            frmCrop.Show()

        Catch exc As Exception
            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub pbResize_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbResize.MouseDown
        'Crop Code
        Try
            If e.Button = MouseButtons.Left Then
                cropX = e.X
                cropY = e.Y
                oCropX = e.X
                oCropY = e.Y
                cropPen = New Pen(cropPenColor, cropPenSize)
                cropPen.DashStyle = cropDashStyle
            End If

            'clear the previoius crop lines by clicking on the pic
            pbResize.Refresh()

        Catch exc As Exception
            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub pbResize_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbResize.MouseEnter
        'Crop Code
        Cursor = Cursors.Cross
    End Sub
    Private Sub pbResize_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbResize.MouseLeave
        'Crop Code
        Cursor = Cursors.Default
    End Sub
    Private Sub pbResize_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbResize.MouseMove
        'Crop Code
        Try
            If pbResize.Image Is Nothing Then Exit Sub
            If e.Button = MouseButtons.Left Then
                'need to take into count where the mouse started at
                'and calculate the new position
                If e.X - cropX <> cropWidth Or e.Y - cropY <> cropHeight Then
                    'clear the previous drawn crop lines
                    pbResize.Refresh()
                    If e.Y > oCropY Then
                        cropHeight = e.Y - cropY
                    Else
                        cropHeight = oCropY - e.Y
                        cropY = e.Y
                    End If
                    If e.X > oCropX Then
                        cropWidth = e.X - cropX
                    Else
                        cropWidth = oCropX - e.X
                        cropX = e.X
                    End If
                    pbResize.CreateGraphics.DrawRectangle(cropPen, cropX, cropY, cropWidth, cropHeight)

                    'update the cropped coordinates 
                    tssCropsize.Text = "Size = " & cropWidth & " x " & cropHeight

                End If
            End If
            'release as much memory as possible
            GC.Collect()
        Catch exc As Exception
            'this is a error when the cropping parameters are less than 1
            If Err.Number = 5 Then Exit Sub
            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub pbResize_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbResize.MouseUp
        'Crop Code
        Try
        Catch exc As Exception
            MessageBox.Show(exc.Message, " Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub pbxRotLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxRotLeft.Click
        pbResize.Image.RotateFlip(RotateFlipType.Rotate270FlipNone)
        redopic()
        pbResize.Refresh()
    End Sub
    Private Sub pbxRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxRight.Click
        pbResize.Image.RotateFlip(RotateFlipType.Rotate90FlipNone)
        redopic()
        pbResize.Refresh()
    End Sub

    Private Sub pbxMirror_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbxMirror.Click
        pbResize.Image.RotateFlip(RotateFlipType.RotateNoneFlipX)
        redopic()
        pbResize.Refresh()
    End Sub

    Private Sub frmImage_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.btnCrop.Location = New Point(220, Me.ClientSize.Height - 70)
        Me.pbxRotLeft.Location = New Point(300, Me.ClientSize.Height - 70)
        Me.pbxRight.Location = New Point(340, Me.ClientSize.Height - 70)
        Me.pbxMirror.Location = New Point(380, Me.ClientSize.Height - 70)
    End Sub
End Class
